addHook("AbilitySpecial", function(player)
    if player.mo.skin == "phoenix"
		if player.powers[pw_super] and player.dualdelay == 0 and not (player.mo.eflags & MFE_UNDERWATER) and player.abilityused < 2
			player.dualdelay = $ + TICRATE/3
			P_SetObjectMomZ(player.mo, 15*FRACUNIT)
			S_StartSound(player.mo,sfx_s3k81)
			player.mo.state = S_PLAY_ROLL
			player.ghosttrail = 1
			player.abilityused = $ + 1
			player.mo.colorized = true
			P_NukeEnemies(player.mo, player.mo, 3208*FRACUNIT)
		end
	end
end)

addHook("JumpSpinSpecial", function(player)
	if player.mo.skin == "phoenix"
		if player.powers[pw_super] and player.dualdelay == 0 and player.abilityused < 2
			player.dualdelay = $ + TICRATE/3
			player.abilityused = $ + 1
			P_SetObjectMomZ(player.mo, 3*FRACUNIT)
			S_StartSound(player.mo,sfx_zoom)
			player.mo.state = S_PLAY_ROLL
			P_Thrust(player.mo, player.mo.angle, 24*FRACUNIT)
		end
	end
end)

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "phoenix"
        return
    end
    
    if player.meleeused < 3 and (player.cmd.buttons & BT_CUSTOM1) and not P_IsObjectOnGround(player.mo) and player.spindelay == 0 and player.powers[pw_super]
		player.mo.state = S_PLAY_MELEE
		P_SetObjectMomZ(player.mo, 23*FRACUNIT)
		player.pflags = $1|PF_SPINNING|PF_THOKKED
		player.mo.tics = 2
		player.meleeused = $ + 1
		S_StartSound(player.mo, sfx_s3k42)
		player.spindelay = $ + TICRATE/2
		P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
	end
end)